Project Chrono: chrono::ChLoadBase Class Reference

Public Member Functions | Protected Attributes | List of all members
chrono::ChLoadBase Class Referenceabstract

## Description

Base class for loads.

This class can be inherited to implement applied loads to bodies, finite elements, etc. A load is an object that might wrap one or more ChLoader objects, whose value is dependent. It implements functionalities to perform automatic differentiation of the load so it optionally can compute the Jacobian (the tangent stiffness matrix of the load) that can be used in implicit integrators, statics, etc.

`#include <ChLoad.h>`

Inheritance diagram for chrono::ChLoadBase:
[legend]
Collaboration diagram for chrono::ChLoadBase:
[legend]

## Public Member Functions
virtual int | LoadGetNumCoordsPosLevel ()=0
| Gets the number of DOFs affected by this load (position part).
virtual int | LoadGetNumCoordsVelLevel ()=0
| Gets the number of DOFs affected by this load (speed part).
virtual void | LoadGetStateBlock_x (ChState &mD)=0
| Gets all the current DOFs packed in a single vector (position part).
virtual void | LoadGetStateBlock_w (ChStateDelta &mD)=0
| Gets all the current DOFs packed in a single vector (speed part).
virtual void | LoadStateIncrement (const ChState &x, const ChStateDelta &dw, ChState &x_new)=0
| Increment a packed state (e.g., as obtained by LoadGetStateBlock_x()) by a given packed state-delta.
virtual int | LoadGetNumFieldCoords ()=0
| Number of coordinates in the interpolated field.
virtual void | ComputeQ (ChState *state_x, ChStateDelta *state_w)=0
| Compute the generalized load(s).
virtual void | ComputeJacobian (ChState *state_x, ChStateDelta *state_w)=0
| Compute the K=-dQ/dx, R=-dQ/dv, M=-dQ/da Jacobians.
ChLoadJacobians * | GetJacobians ()
| Access the Jacobians (if any, i.e. if this is a stiff load).
virtual void | CreateJacobianMatrices ()=0
| Create the Jacobian loads if needed and set the ChVariables referenced by the sparse KRM block.
virtual void | Update (double time)
| Update, called at least at each time step.
virtual bool | IsStiff ()=0
| Report if this is load is stiff.
virtual void | LoadIntLoadResidual_F (ChVectorDynamic<> &R, double c)=0
| Add the internal loads Q (pasted at global offsets) into a global vector R, multiplied by a scaling factor c.
virtual void | LoadIntLoadResidual_Mv (ChVectorDynamic<> &R, const ChVectorDynamic<> &w, double c)=0
| Increment a vector R with the matrix-vector product M*w, scaled by the factor c.
virtual void | LoadIntLoadLumpedMass_Md (ChVectorDynamic<> &Md, double &err, const double c)=0
| Add the lumped mass to an Md vector, representing a mass diagonal matrix.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor)
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
virtual ChObj * | Clone () const =0
| "Virtual" copy constructor.
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual void | ArchiveOut (ChArchiveOut &archive_out)
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in)
| Method to allow de-serialization of transient data from archives.
virtual std::string & | ArchiveContainerName ()

## Protected Attributes
ChLoadJacobians * | m_jacobians
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Additional Inherited Members
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()

## Member Function Documentation

## ◆ ComputeJacobian()

virtual void chrono::ChLoadBase::ComputeJacobian | ( | ChState * | state_x,
|  | ChStateDelta * | state_w )
| pure virtual

Compute the K=-dQ/dx, R=-dQ/dv, M=-dQ/da Jacobians.

Implementation in a derived class should load the Jacobian matrices K, R, M in the structure 'm_jacobians'. Note the sign that is flipped because we assume equations are written with Q moved to left-hand side.

Parameters

  state_x | state position to evaluate Jacobians
  state_w | state speed to evaluate Jacobians

Implemented in chrono::ChLoad, chrono::ChLoadBodyInertia, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ ComputeQ()

virtual void chrono::ChLoadBase::ComputeQ | ( | ChState * | state_x,
|  | ChStateDelta * | state_w )
| pure virtual

Compute the generalized load(s).

A derived class should cache the resulting Q which is then used in LoadIntLoadResidual_F.

Parameters

  state_x | state position to evaluate Q
  state_w | state speed to evaluate Q

Implemented in chrono::ChLoad, chrono::ChLoadBodyBody, chrono::ChLoadBodyForce, chrono::ChLoadBodyInertia, chrono::ChLoadBodyMesh, chrono::ChLoadBodyTorque, chrono::ChLoadNodeXYZBody, chrono::ChLoadNodeXYZForce, chrono::ChLoadNodeXYZNodeXYZ, chrono::ChShaftsElasticGear, chrono::ChShaftsLoad, chrono::fea::ChLoadNodeXYZRot, chrono::fea::ChLoadNodeXYZRotBody, and chrono::fea::ChLoadNodeXYZRotNodeXYZRot.

## ◆ CreateJacobianMatrices()

virtual void chrono::ChLoadBase::CreateJacobianMatrices | ( |  | ) |
| pure virtual

Create the Jacobian loads if needed and set the ChVariables referenced by the sparse KRM block.

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ InjectKRMMatrices()

void chrono::ChLoadBase::InjectKRMMatrices | ( | ChSystemDescriptor & | descriptor | ) |
| virtual

Register with the given system descriptor any ChKRMBlock objects associated with this item.

Reimplemented in chrono::ChLoadBodyMesh.

## ◆ IsStiff()

virtual bool chrono::ChLoadBase::IsStiff | ( |  | ) |
| pure virtual

Report if this is load is stiff.

If so, InjectKRMMatrices will provide the Jacobians of the load.

Implemented in chrono::ChLoad, chrono::ChLoadBodyBodyBushingGeneric, chrono::ChLoadBodyBodyBushingSpherical, chrono::ChLoadBodyMesh, chrono::ChLoadNodeXYZBodyBushing, chrono::ChLoadNodeXYZBodySpring, chrono::ChLoadNodeXYZForce, chrono::ChLoadNodeXYZForceAbs, chrono::ChLoadNodeXYZNodeXYZ, chrono::ChLoadNodeXYZNodeXYZBushing, chrono::ChLoadNodeXYZNodeXYZSpring, chrono::ChShaftsElasticGear, chrono::ChShaftsTorsionSpringDamper, chrono::fea::ChLoadNodeXYZRot, chrono::fea::ChLoadNodeXYZRotBodyBushingGeneric, chrono::fea::ChLoadNodeXYZRotBodyBushingSpherical, chrono::fea::ChLoadNodeXYZRotForceAbs, chrono::fea::ChLoadNodeXYZRotNodeXYZRotBushingGeneric, and chrono::fea::ChLoadNodeXYZRotNodeXYZRotBushingSpherical.

## ◆ LoadGetNumCoordsPosLevel()

virtual int chrono::ChLoadBase::LoadGetNumCoordsPosLevel | ( |  | ) |
| pure virtual

Gets the number of DOFs affected by this load (position part).

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadGetNumCoordsVelLevel()

virtual int chrono::ChLoadBase::LoadGetNumCoordsVelLevel | ( |  | ) |
| pure virtual

Gets the number of DOFs affected by this load (speed part).

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadGetNumFieldCoords()

virtual int chrono::ChLoadBase::LoadGetNumFieldCoords | ( |  | ) |
| pure virtual

Number of coordinates in the interpolated field.

For example, 3 for a tetrahedron finite element or a cable, 1 for a thermal problem, etc.

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadGetStateBlock_w()

virtual void chrono::ChLoadBase::LoadGetStateBlock_w | ( | ChStateDelta & | mD | ) |
| pure virtual

Gets all the current DOFs packed in a single vector (speed part).

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadGetStateBlock_x()

virtual void chrono::ChLoadBase::LoadGetStateBlock_x | ( | ChState & | mD | ) |
| pure virtual

Gets all the current DOFs packed in a single vector (position part).

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadIntLoadLumpedMass_Md()

virtual void chrono::ChLoadBase::LoadIntLoadLumpedMass_Md | ( | ChVectorDynamic<> & | Md,
|  | double & | err,
|  | const double | c )
| pure virtual

Add the lumped mass to an Md vector, representing a mass diagonal matrix.

In other words, perform the operation: Md += c*diag(M). Used by lumped explicit integrators. If mass lumping is impossible or approximate, adds scalar error to "err" parameter. If no mass matrix M is present (i.e., no inertial effects), implement as no-op.

Parameters

  Md | result: Md vector, diagonal of the lumped mass matrix
  err | result: not touched if lumping does not introduce errors
  c | a scaling factor

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadIntLoadResidual_F()

virtual void chrono::ChLoadBase::LoadIntLoadResidual_F | ( | ChVectorDynamic<> & | R,
|  | double | c )
| pure virtual

Add the internal loads Q (pasted at global offsets) into a global vector R, multiplied by a scaling factor c.

In other words, perform the operation: R += forces * c

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadIntLoadResidual_Mv()

virtual void chrono::ChLoadBase::LoadIntLoadResidual_Mv | ( | ChVectorDynamic<> & | R,
|  | const ChVectorDynamic<> & | w,
|  | double | c )
| pure virtual

Increment a vector R with the matrix-vector product M*w, scaled by the factor c.

In other words, perform the operation: R += c*M*w (i.e., R += c*(-dQ/da)*w). If no mass matrix M is present (i.e., no inertial effects), implement as no-op.

Parameters

  R | result: the R residual, R += c*M*v
  w | the w vector
  c | scaling factor

Implemented in chrono::ChLoad, chrono::ChLoadBodyInertia, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ LoadKRMMatrices()

void chrono::ChLoadBase::LoadKRMMatrices | ( | double | Kfactor,
|  | double | Rfactor,
|  | double | Mfactor )
| virtual

Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.

The resulting KRM blocks represent linear combinations of the K, R, and M matrices, with the specified coefficients Kfactor, Rfactor,and Mfactor, respectively.

Reimplemented in chrono::ChLoadBodyMesh.

## ◆ LoadStateIncrement()

virtual void chrono::ChLoadBase::LoadStateIncrement | ( | const ChState & | x,
|  | const ChStateDelta & | dw,
|  | ChState & | x_new )
| pure virtual

Increment a packed state (e.g., as obtained by LoadGetStateBlock_x()) by a given packed state-delta.

Compute: x_new = x + dw. This method is used in calculating Jacobians with finite difference approximations (default implementations of ComputeJacobian).

Implemented in chrono::ChLoad, chrono::ChLoadBodyMesh, chrono::ChLoadCustom, and chrono::ChLoadCustomMultiple.

## ◆ Update()

void chrono::ChLoadBase::Update | ( | double | time | ) |
| virtual

Update, called at least at each time step.

- It recomputes the generalized load Q vector(s)
- It recomputes the Jacobian matrices K,R,M in case of stiff load Q and Jacobians assumed evaluated at the current state. Jacobians are automatically allocated if needed.

Reimplemented in chrono::ChLoadNodeXYZForce, chrono::ChLoadNodeXYZForceAbs, chrono::ChLoadNodeXYZNodeXYZ, chrono::fea::ChLoadNodeXYZRot, and chrono::fea::ChLoadNodeXYZRotForceAbs.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLoad.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChLoad.cpp